﻿using System;using UnityEngine;using System.Collections;using System.Collections.Generic;using SimpleJSON;using System.Linq; using UnityEngine.UI;
using MVR.FileManagementSecure;
namespace JayJayWon{
    public class VUML : MVRScript{
        const string pluginName = "VUML";const string pluginAuthor = "JayJayWon"; const string pluginVersion = "v1.9";		
        public static Dictionary<string,string> MAPReceiversToGroups = new Dictionary<string, string>()   {
            {"Preset","Presets"},{"plugin#","Plugins" }, {"Trigger","Collision Triggers" },{"Animation","Node Animations" },{"animation","Node Animations" },{"Hair","Hair" }, {"hair","Hair" },{"Ponytail","Hair" }, {"Wrap","Clothing" },{"Sim","Clothing" }, {"Style","Clothing" },{"Material","Clothing" },{"Item","Clothing" },{"Clothing","Clothing" },{"BreastPhysicsMesh","Physics" },{"LowerPhysicsMesh","Physics" },{"control","Physics" },{"rescaleObject","Physics" },{"Physics","Physics" },{"Control","Node Controls" },{"Eye","Skin & Eyes" }, {"sclera","Skin & Eyes" },{"irises","Skin & Eyes" },{"skin","Skin & Eyes" },{"textures","Skin & Eyes" }, {"Skin","Skin & Eyes" }, {"lacrimal","Skin & Eyes" },{"mouth","Skin & Eyes" },{"teeth","Skin & Eyes" },{"tongue","Skin & Eyes" },{"Anatomy","Skin & Eyes" },{"HeadAudioSource","Speech" }, {"Speech","Speech" },{"Thought","Speech" },{"Auto","Speech" } };
		public static Dictionary<string,string> MAPReceiverGeometryParamsToGroup= new Dictionary <string,string>(){
			{"clothing:","Clothing"},{"toggle:","Clothing"},{"hair","Hair"},{"Colliders","Physics"}, {"disable","Skin & Eyes"},{"character","Skin & Eyes"}, {"use","Skin & Eyes" }};
        public string GetLocalPluginPath()
        {
            string pluginId = storeId.Split('_')[0];
            string pathToScriptFile = manager.GetJSON(true, true)["plugins"][pluginId].Value;
            string pathToScriptFolder = pathToScriptFile.Substring(0, pathToScriptFile.LastIndexOfAny(new char[] { '/', '\\' }) + 1);
            pathToScriptFolder = pathToScriptFolder.Replace('/', '\\');
			if (pathToScriptFolder.Contains(":"))pathToScriptFolder=pathToScriptFolder.Substring(pathToScriptFolder.IndexOf(':')+1);
			char[] charsToTrim = { '/', '\\'};
			pathToScriptFolder = pathToScriptFolder.Trim(charsToTrim);
			bool exists = FileManagerSecure.DirectoryExists(pathToScriptFolder);
			if(!exists)pathToScriptFolder="Custom\\Scripts";
			return pathToScriptFolder;
        }
        public override void Init() {
			try {
				
				var btn = CreateButton("Load VUML Variables"); 
				btn.button.onClick.AddListener(() =>{
					SuperController.singleton.GetMediaPathDialog(LoadFileSelected,"vuml",GetLocalPluginPath(),false,true,false);
					
					});
                
				btn = CreateButton("Save VUML Variables"); 
				btn.button.onClick.AddListener(() =>{
					SuperController.singleton.GetMediaPathDialog(SaveFileSelected,"vuml",GetLocalPluginPath(),false,true,false);
					uFileBrowser.FileBrowser browser = SuperController.singleton.mediaFileBrowserUI;
					browser.SetTextEntry(true);
					browser.fileEntryField.text = String.Format("{0}.{1}", ((int)(DateTime.UtcNow - new DateTime(1970, 1, 1)).TotalSeconds).ToString(), "vuml");
					browser.ActivateFileNameField();						
					
					});
				JSONStorableAction loadVUMLVars = new JSONStorableAction("LoadVUMLVars", () =>{LoadVUMLVars () ;});
				RegisterAction(loadVUMLVars);
				JSONStorableAction saveVUMLVars = new JSONStorableAction("SaveVUMLVars", () =>{SaveVUMLVars () ;});
				RegisterAction(saveVUMLVars);
				_loadSaveVUMLFileJSON = new  JSONStorableString ("LoadSaveVUMLFileName","");
				RegisterString (_loadSaveVUMLFileJSON);
				
				btn = CreateButton("Add vBOOL"); btn.button.onClick.AddListener(() =>{CreateNextVariable("BOOL");}); btn = CreateButton("Add vFLOAT"); btn.button.onClick.AddListener(() =>{CreateNextVariable("FLOAT");}); btn = CreateButton("Add vSTRING"); btn.button.onClick.AddListener(() =>{CreateNextVariable("STRING");});
				
                _currentVariableChooser = new JSONStorableStringChooser("variableChooser", null, "NONE", "", SwitchVariable);_currentVariableChooser.storeType = JSONStorableParam.StoreType.Full;			
				_displayVariableChooserPopup = CreateSetupScrollablePopup(_currentVariableChooser, true, 1000f, UpdateVariableChooserList, "VUML Variable");
				_uiVariable = new VUMLVariable ("BOOL",0,"vBOOL0", this);
				_atomRenameHandle = new SuperController.OnAtomUIDRename(this.AtomNameUpdate);SuperController.singleton.onAtomUIDRenameHandlers += _atomRenameHandle;
				
				
				_pluginVersionJSON = new JSONStorableString("PluginVersion","");
				_pluginVersionJSON.val = pluginName +" "+pluginVersion + "\nby "+pluginAuthor;	_resultSummary = new JSONStorableString ("ResultSummary","");_displayNotes = new JSONStorableBool("DisplayVarNotes",false);

				uiRefreshLeft();
			}catch (Exception e) {SuperController.LogError("Exception caught: " + e);}
		}
		private void SaveFileSelected(string fileName){
			try {
				if (fileName !=""){
					_loadSaveVUMLFileJSON.val = fileName;
					SaveVUMLVars();
				}
			}catch (Exception e) {SuperController.LogError("Exception caught: " + e);}
		}			
		
		private void LoadFileSelected(string fileName){
			try {
				if (fileName !=""){
					_loadSaveVUMLFileJSON.val = fileName;
					LoadVUMLVars();
				}
			}catch (Exception e) {SuperController.LogError("Exception caught: " + e);}
		}
		
		private void LoadVUMLVars () {
			if (FileManagerSecure.FileExists(_loadSaveVUMLFileJSON.val)){
				JSONNode loadJson = SuperController.singleton.LoadJSON(_loadSaveVUMLFileJSON.val);
				foreach (VUMLVariable varToRemove in _vumlVariableList) varToRemove.DeregisterVariable();

				_vumlVariableList.Clear();
				_vumlVariableDict.Clear();
				_boolCountInt =0;
				_floatCountInt =0;
				_stringCountInt=0;
				ImportVariablesFromJson(loadJson);
				if(_boolCountInt > 0||_stringCountInt > 0||_floatCountInt > 0){_currentVariableChooser.val = _currentVariableChooser.choices[0];	}
			}
		}
		private void SaveVUMLVars () {			
				SuperController.singleton.SaveJSON(this.GetJSON(),_loadSaveVUMLFileJSON.val);
		}
		protected void uiRefreshLeft(){
			if(_copyVariableButton!=null){RemoveButton(_copyVariableButton);}
			if(_displaySpacer1!=null){RemoveSpacer(_displaySpacer1);}
			if(_resultSummaryTextField!=null){RemoveTextField(_resultSummaryTextField);}
			if(_displaySpacer2!=null){RemoveSpacer(_displaySpacer2);}
			if(_pluginVersionTextField!=null){RemoveTextField(_pluginVersionTextField);}
			if(_dispNotesToggle!=null){RemoveToggle(_dispNotesToggle);}
			if (_floatCountInt+_boolCountInt+_stringCountInt>0){_copyVariableButton = CreateButton("Duplicate "+_currentVariableChooser.val);_copyVariableButton.button.onClick.AddListener(() =>{CopyVariable();});}			
			_displaySpacer1 = CreateSpacer(false);_displaySpacer1.height = 20;	_resultSummaryTextField = CreateTextField(_resultSummary);_resultSummaryTextField.height =580;_dispNotesToggle = CreateToggle(_displayNotes); _dispNotesToggle.label="Display Notes";	_displaySpacer2 = CreateSpacer(false);_displaySpacer2.height = 20;	_pluginVersionTextField = CreateTextField(_pluginVersionJSON,false);			_pluginVersionTextField.height = 1;
		}
        protected void SwitchVariable(string variableID){
			try {				
                _uiVariable.DisableUpdates(true);
				if (variableID!="NONE"){_uiVariable.CopyVariableFrom(_vumlVariableDict[variableID],false);}
                _uiVariable.DisableUpdates(false);	
				RemovePopup(_displayVariableChooserPopup);
				_displayVariableChooserPopup = CreateSetupScrollablePopup(_currentVariableChooser, true, 1000f, UpdateVariableChooserList, "VUML Variable");
				_uiVariable.initVariableUI();
				uiRefreshLeft();
				_copyVariableButton.buttonText.text = "Duplicate "+variableID;
			}catch (Exception e) {SuperController.LogError("Exception caught: " + e);}
		}
        public static void CloseAllPopup(UIDynamicPopup exception){
			if (_displayVariableChooserPopup != null && _displayVariableChooserPopup != exception) { _displayVariableChooserPopup.popup.visible = false; }
            if (_uiVariable != null){_uiVariable.CloseAllPopup(exception);}
        }
		protected string CreateNextVariable(string varType, VUMLVariable copyVar=null){
			try {
				int varID =0 ;
				if (varType=="BOOL"){_boolCountInt = _boolCountInt +1;varID= _boolCountInt;}
				if (varType=="FLOAT"){_floatCountInt = _floatCountInt +1;varID= _floatCountInt;}
				if (varType=="STRING"){_stringCountInt = _stringCountInt +1;varID= _stringCountInt;}			
				string newVarName = "v" + varType+varID.ToString();
				VUMLVariable newVar = AddVariable(varType,varID,newVarName);
				if (copyVar != null) { newVar.CopyVariableFrom(copyVar, false); }
				else{_uiVariable.DisableUpdates(true);_uiVariable.ResetDefaults(varType); newVar.CopyVariableFrom(_uiVariable, false);_uiVariable.DisableUpdates(false); }
				_currentVariableChooser.val = newVarName;
				UpdateVariableChooserList();
				newVar.RegisterVariable(); 
				uiRefreshLeft();
				return newVarName ;
			}catch (Exception e) {SuperController.LogError("Exception caught: " + e);return(null);}
		}
        protected VUMLVariable AddVariable(string varType,int varID, string varLabel){
			VUMLVariable newVar = new VUMLVariable(varType, varID, varLabel,this); 
			_vumlVariableDict[varLabel] = newVar; 
			_vumlVariableList.Add(newVar); 
			return newVar;
		}
        JSONNode GetPluginJsonFromSave(string atomName, string storeName){
            foreach (JSONNode atoms in SuperController.singleton.GetSaveJSON()["atoms"].AsArray){if (atoms["id"].Value == atomName){
                    foreach (JSONNode storable in atoms["storables"].AsArray){if (storable["id"].Value == storeName){return storable;}}
                }
            }
            return null;
        }
        JSONNode GetPluginJsonFromLoad(string atomName, string storeName){
            foreach (JSONNode atoms in SuperController.singleton.loadJson ["atoms"].AsArray){
                if (atoms["id"].Value == atomName){foreach (JSONNode storable in atoms["storables"].AsArray) {if (storable["id"].Value == storeName) { return storable; } }}
            }
            return null;
        }
		protected void RefreshVarCounts(JSONNode varSaveJSON){
			foreach (KeyValuePair<string, JSONNode> kvp in (JSONClass)varSaveJSON){
				if (kvp.Key.Length>13){
					if (kvp.Key.Substring(kvp.Key.Length-13,13)=="OperationType"){
						int varID = 0;
						if (kvp.Key.Substring(0,5)=="vBOOL"){Int32.TryParse(kvp.Key.Substring(5,kvp.Key.Length-5-13), out varID);_boolCountInt =Math.Max(varID,_boolCountInt);}
						if (kvp.Key.Substring(0,6)=="vFLOAT"){Int32.TryParse(kvp.Key.Substring(6,kvp.Key.Length-6-13), out varID);_floatCountInt =Math.Max(varID,_floatCountInt);}
						if (kvp.Key.Substring(0,7)=="vSTRING"){Int32.TryParse(kvp.Key.Substring(7,kvp.Key.Length-7-13), out varID);_stringCountInt =Math.Max(varID,_stringCountInt);}
					}
				}
			}		
		}
		protected void ImportVariablesFromJson(JSONNode savedJson){
			if (savedJson!=null){RefreshVarCounts(savedJson);}
			if(_boolCountInt > 0){
				_uiVariable.DisableUpdates(true);_uiVariable.ResetDefaults("BOOL"); _uiVariable.DisableUpdates(false);				
				for (int index = 1; index <= _boolCountInt; index++){ 
					VUMLVariable newVar = AddVariable("BOOL",index,"vBOOL"+index.ToString());
					newVar.CopyVariableFrom(_uiVariable, false);
					newVar.RestoreFromJSON("vBOOL"+index.ToString(), savedJson);
					newVar.RegisterVariable(); 
				}
			}
			if(_floatCountInt > 0){
				_uiVariable.DisableUpdates(true);_uiVariable.ResetDefaults("FLOAT"); _uiVariable.DisableUpdates(false);
				for (int index = 1; index <= _floatCountInt; index++){ 
					VUMLVariable newVar = AddVariable("FLOAT",index,"vFLOAT"+index.ToString()); 
					newVar.CopyVariableFrom(_uiVariable, false);
					newVar.RestoreFromJSON("vFLOAT"+index.ToString(), savedJson);
					newVar.RegisterVariable(); 
				}
			}
			if(_stringCountInt > 0){
				_uiVariable.DisableUpdates(true);_uiVariable.ResetDefaults("STRING"); _uiVariable.DisableUpdates(false);
				for (int index = 1; index <= _stringCountInt; index++){ 
					VUMLVariable newVar = AddVariable("STRING",index,"vSTRING"+index.ToString()); 
					newVar.CopyVariableFrom(_uiVariable, false);
					newVar.RestoreFromJSON("vSTRING"+index.ToString(), savedJson);
					newVar.RegisterVariable(); 
				}
			}
            UpdateVariableChooserList();			
		}

        public override void RestoreFromJSON(JSONClass jc, bool restorePhysical = true, bool restoreAppearance = true, JSONArray presetAtoms = null, bool setMissingToDefault = true)
        {
            
            try
            {
                base.RestoreFromJSON(jc, restorePhysical, restoreAppearance, presetAtoms, setMissingToDefault);
				
				foreach (VUMLVariable varToRemove in _vumlVariableList) varToRemove.DeregisterVariable();
				_vumlVariableList.Clear();
				_vumlVariableDict.Clear();
				_boolCountInt =0;
				_floatCountInt =0;
				_stringCountInt=0;
				
				ImportVariablesFromJson(jc);
            }
            catch (Exception e) { SuperController.LogError("Exception caught: " + e); }

        }

		protected void CopyVariable(){
			try{string newActName = CreateNextVariable(_uiVariable._variableType, _uiVariable);}
			catch (Exception e) { SuperController.LogError("Exception caught: " + e); }}
		public void DeleteVariable(){
			try{
				VUMLVariable varToRemove = _vumlVariableDict[_currentVariableChooser.val];
				if (varToRemove._variableType=="BOOL"){_boolCountInt =_boolCountInt -1;}
				if (varToRemove._variableType=="STRING"){_stringCountInt =_stringCountInt -1;}
				if (varToRemove._variableType=="FLOAT"){_floatCountInt =_floatCountInt -1;}
				varToRemove.DeregisterVariable();_vumlVariableList.Remove(varToRemove);_vumlVariableDict.Remove(_currentVariableChooser.val);UpdateVariableChooserList();
				if (_currentVariableChooser.choices.Count>0 ){_currentVariableChooser.val = _currentVariableChooser.choices[0];}
				else{_currentVariableChooser.val ="NONE";}				        
				uiRefreshLeft();
			}catch (Exception e) {SuperController.LogError("Exception caught: " + e);}
		}
		protected void UpdateVariableChooserList(){
			List <string> varChoices = new List <string>() ; 
			VUML.CloseAllPopup(_displayVariableChooserPopup);
            foreach (VUMLVariable vumlVar in _vumlVariableList){if(vumlVar._variableType =="BOOL"){varChoices.Add(vumlVar._varLabel);}}
			foreach (VUMLVariable vumlVar in _vumlVariableList){if(vumlVar._variableType =="FLOAT"){varChoices.Add(vumlVar._varLabel);}}
			foreach (VUMLVariable vumlVar in _vumlVariableList){if(vumlVar._variableType =="STRING"){varChoices.Add(vumlVar._varLabel);}}
			_currentVariableChooser.choices = new List<string>();_currentVariableChooser.choices = varChoices;
		}
		protected void ParamAtomNameUpdate (VariableParam param, string oldName, string newName){
			if (param._atomName.val.Substring(param._atomName.val.Length-1,1)==">"){
				string atomName = param._atomName.val.Substring(0,param._atomName.val.Length-1);
				if (atomName == oldName){param._atomName.val = newName +">";}	
			}
			else if (param._atomName.val!="LOCAL VUML"){
				String[] strlist = param._atomName.val.Split('>');
				if (strlist[0]==oldName){param._atomName.val = newName +">"+ strlist[1];}
			}
		}	
		protected void AtomNameUpdate(string oldName, string newName){
			try{
				foreach (VUMLVariable vumlVar in _vumlVariableList){
					ParamAtomNameUpdate (vumlVar._paramA,oldName,newName);
					ParamAtomNameUpdate (vumlVar._paramA,oldName,newName);
				}
				ParamAtomNameUpdate (_uiVariable._paramA,oldName,newName);
				ParamAtomNameUpdate (_uiVariable._paramB,oldName,newName);
			}catch (Exception e) {SuperController.LogError("Exception caught: " + e);}
		}
		void Start() {
			try	{
				if(_boolCountInt > 0||_stringCountInt > 0||_floatCountInt > 0){_currentVariableChooser.val = _currentVariableChooser.choices[0];	}
			}catch (Exception e) {SuperController.LogError("Exception caught: " + e);}
		}
		protected long GetTimeNow (bool scaledTime = false){long msTime ; if (!scaledTime) { msTime = (long)(Time.unscaledTime * 1000); } else { msTime = (long) (Time.time *1000); }return (msTime);}
		public UIDynamicPopup CreateSetupScrollablePopup(JSONStorableStringChooser stringChooserJSON, bool rightUI, float panelHeight, UIPopup.OnOpenPopup callbackMethod,string label){
			UIDynamicPopup dynamicPopup = CreateScrollablePopup(stringChooserJSON, rightUI);dynamicPopup.popupPanelHeight = panelHeight;dynamicPopup.popup.onOpenPopupHandlers += callbackMethod ;dynamicPopup.label = label;return(dynamicPopup);
		}
		public UIDynamicTextField CreateTextInput(JSONStorableString jss, bool rightSide = false){
			UIDynamicTextField textfield = CreateTextField(jss, rightSide);textfield.height = 1f;textfield.backgroundColor = Color.white;var input = textfield.gameObject.AddComponent<InputField>();input.textComponent = textfield.UItext;input.lineType = InputField.LineType.MultiLineNewline;input.textComponent.resizeTextMaxSize = 30;input.textComponent.resizeTextForBestFit = true;jss.inputField = input;return(textfield);
		}	
        public void SaveUIVariable(){_vumlVariableDict[_currentVariableChooser.val].CopyVariableFrom(_uiVariable,false);_vumlVariableDict[_currentVariableChooser.val].RegisterVariable(); }
		void OnDestroy() {SuperController.singleton.onAtomUIDRenameHandlers -= _atomRenameHandle;foreach (VUMLVariable vumlVar in _vumlVariableList){vumlVar.RemoveCollider();}}
		void Update() {
			try {
				if (!SuperController.singleton.isLoading&&(_boolCountInt+_floatCountInt+_stringCountInt)>0 ){				
					string resultUpdate ="";
					List<string> vumlBoolVarNames = new List<string>();List<string> vumlFloatVarNames = new List<string>();List<string> vumlStringVarNames = new List<string>();		
					if (_uiVariable._operationType.val=="Static"){
						VUMLVariable currentVariable = _vumlVariableDict[_currentVariableChooser.val];
						_uiVariable._variableBoolResult.val = currentVariable._variableBoolResult.val;
						_uiVariable._variableFloatResult.val = currentVariable._variableFloatResult.val;
						_uiVariable._variableStringResult.val = currentVariable._variableStringResult.val;}
					foreach (VUMLVariable vumlVar in _vumlVariableList){
						string result ="";
						if (vumlVar._calcFrequency.val == "Continuous"){vumlVar.UpdateResult();}
						string notes ="";
						if (_displayNotes.val && vumlVar._notes.val!="" && vumlVar._notes.val!="Notes"){notes=" ["+vumlVar._notes.val+"]";};
						if (vumlVar._variableType =="BOOL"){result = vumlVar._variableBoolResult.val.ToString();vumlBoolVarNames.Add(vumlVar._varLabel+": "+result+notes);}
						else if (vumlVar._variableType =="FLOAT"){ result = vumlVar._variableFloatResult.val.ToString();vumlFloatVarNames.Add(vumlVar._varLabel+": "+result+notes);}
						else if (vumlVar._variableType =="STRING"){ result = vumlVar._variableStringResult.val;vumlStringVarNames.Add(vumlVar._varLabel+": "+result+notes);}			
						
					}					
					foreach (string varName in vumlBoolVarNames){resultUpdate = resultUpdate + varName + "\n";}
					foreach (string varName in vumlFloatVarNames){resultUpdate = resultUpdate + varName + "\n";}
					foreach (string varName in vumlStringVarNames){resultUpdate = resultUpdate + varName + "\n";}
					_resultSummary.val = resultUpdate;
					if (_uiVariable._calcFrequency.val =="Continuous" && _uiVariable._operationType.val!="Timer"){_uiVariable.UpdateResult();}
                }
			}catch (Exception e) {SuperController.LogError("Exception caught in "+containingAtom.name+" "+this.storeId+": " + e);}
		}
		public JSONStorableStringChooser _currentVariableChooser;public JSONStorableString _resultSummary ;protected JSONStorableString _pluginVersionJSON;	protected JSONStorableBool _displayNotes;
		protected UIDynamicButton _copyVariableButton;protected static UIDynamicPopup _displayVariableChooserPopup;protected UIDynamicTextField _resultSummaryTextField;protected UIDynamicTextField _pluginVersionTextField;		protected UIDynamic _displaySpacer1 ;protected UIDynamic _displaySpacer2 ;public static VUMLVariable _uiVariable ; protected UIDynamicToggle _dispNotesToggle;
        List<VUMLVariable> _vumlVariableList = new List<VUMLVariable>();SuperController.OnAtomUIDRename _atomRenameHandle ;
        public Dictionary<string, VUMLVariable> _vumlVariableDict = new Dictionary<string, VUMLVariable>();
		public int _boolCountInt =0; public int _floatCountInt =0; public int _stringCountInt =0;
		public JSONStorableString _loadSaveVUMLFileJSON ;
	}	
	public class VUMLVariable{
        public VUMLVariable(string varType, int varID, string varLabel, VUML parent ){
			_variableID = varID;_variableType = varType;_varLabel = varLabel;_parent = parent;	
			_paramA = new VariableParam (varType,varID,"A",varLabel,this);
			_paramB = new VariableParam (varType,varID,"B",varLabel,this);
			_operationType = new JSONStorableStringChooser(varLabel+"OperationType",null,"","");
			_operationType.storeType = JSONStorableParam.StoreType.Full;
			_operation = new JSONStorableStringChooser(varLabel+"Operation",null,"","");
			_operation.storeType = JSONStorableParam.StoreType.Full;		
			_calcFrequency = new JSONStorableStringChooser(varLabel+"CalcFrequency",null,"","");	
			if(varID>0){_exectuteOperation = new JSONStorableAction (varLabel+"ExecuteUpdate",()=>{UpdateResult();});}
			if(varID>0){_resetTimer = new JSONStorableAction (varLabel+"ResetTimer",()=>{ResetTimer();});}
			if(varID>0){_incrementCounter = new JSONStorableAction (varLabel+"IncrementCounter",()=>{UpdateCounter("Increment");});}
			if(varID>0){_decrementCounter = new JSONStorableAction (varLabel+"DecrementCounter",()=>{UpdateCounter("Decrement");});}
			if(varID>0){_resetCounter = new JSONStorableAction (varLabel+"ResetCounter",()=>{UpdateCounter("Reset");});}		
			_variableBoolResult = new JSONStorableBool (varLabel+"Result",false);
			_variableBoolResult.storeType = JSONStorableParam.StoreType.Full;		
			_variableFloatResult = new JSONStorableFloat (varLabel+"Result",0f,-10000f,10000f,false);
			_variableFloatResult.storeType = JSONStorableParam.StoreType.Full;
			_lookAtFOV = new JSONStorableFloat (varLabel+"LookAtFOV",30f,5f,180f);
			_lookAtFOV.storeType = JSONStorableParam.StoreType.Full;			
			_variableStringResult = new JSONStorableString (varLabel+"Result","", changedText =>{string temp = changedText ;if(!_disableUIUpdates){_parent.SaveUIVariable();}});
			_variableStringResult.storeType = JSONStorableParam.StoreType.Full;
			_notes = new JSONStorableString (varLabel+"Notes","Notes", changedText =>{string temp = changedText ;if(!_disableUIUpdates){_parent.SaveUIVariable();}});
			_notes.storeType = JSONStorableParam.StoreType.Full;
			_variableTimerPaused = new JSONStorableBool (varLabel+"TimerPaused",false);
			_variableTimerPaused.storeType = JSONStorableParam.StoreType.Full;
            if (varID > 0) { _disableUIUpdates = true;_paramA._disableUIUpdates = true;_paramB._disableUIUpdates = true; }
		}
        public void ResetDefaults(string varType){
			_variableType = varType;_operationType.val="Static";_operation.val="";_calcFrequency.val="Continuous";_variableBoolResult.val = false;_variableFloatResult.val = 0f;_lookAtFOV.val = 30f;_variableStringResult.val ="";_notes.val ="Notes";_variableTimerPaused.val = false;_timerStartTime = 0f;_freezeTimeStart = 0f;_pauseTimerStart = 0f;			string defaultAtom ="";
			_paramA.ResetDefaults("LOCAL VUML");
			_paramB.ResetDefaults("LOCAL VUML");			
		}
        public void RegisterVariable(){
			if (_variableType == "FLOAT"){_parent.RegisterFloat(_variableFloatResult);}
			if (_variableType == "BOOL"){_parent.RegisterBool(_variableBoolResult);}
			if (_variableType == "STRING"){_parent.RegisterString(_variableStringResult);}			
			_parent.RegisterStringChooser(_operationType);
			_parent.RegisterStringChooser(_operation);
			_parent.RegisterStringChooser(_calcFrequency);	
			_parent.RegisterString(_notes);
			if (_calcFrequency.val !="Continuous"){_parent.RegisterAction(_exectuteOperation);}
			else{_parent.DeregisterAction(_exectuteOperation);}
			if (_operationType.val == "Timer") {_parent.RegisterAction(_resetTimer);_parent.RegisterBool(_variableTimerPaused);}
			else{_parent.DeregisterAction(_resetTimer);_parent.DeregisterBool(_variableTimerPaused);}
			if(_operationType.val =="Look At"){_parent.RegisterFloat(_lookAtFOV);}
			else{_parent.DeregisterFloat(_lookAtFOV);}
			if(_operationType.val =="Counter"){_parent.RegisterAction(_incrementCounter);_parent.RegisterAction(_decrementCounter);_parent.RegisterAction(_resetCounter);}
			else{
				if(_incrementCounter!=null){_parent.DeregisterAction(_incrementCounter);}
				if(_decrementCounter!=null){_parent.DeregisterAction(_decrementCounter);}
				if (_resetCounter!=null){_parent.DeregisterAction(_resetCounter);}
			}
			if (_paramCount==2){_paramA.RegisterVarParam();	_paramB.RegisterVarParam();}
			if (_paramCount==1){_paramA.RegisterVarParam();	_paramB.DeregisterVarParam();}
			if (_paramCount==0){_paramA.DeregisterVarParam();_paramB.DeregisterVarParam();}
		}
		public void DeregisterVariable(){ 
			_paramA.DeregisterVarParam();_paramB.DeregisterVarParam();
			_parent.DeregisterStringChooser(_operationType);
			_parent.DeregisterStringChooser(_operation);
			_parent.DeregisterStringChooser(_calcFrequency);
			_parent.DeregisterString(_notes);
			_parent.DeregisterFloat(_lookAtFOV);			
			if (_exectuteOperation!=null){_parent.DeregisterAction(_exectuteOperation);}
			if (_variableFloatResult!=null){_parent.DeregisterFloat(_variableFloatResult);}
			if (_variableBoolResult!=null){_parent.DeregisterBool(_variableBoolResult);}
			if (_variableStringResult!=null){_parent.DeregisterString(_variableStringResult);}
			if (_resetTimer!=null){_parent.DeregisterAction(_resetTimer);}
			if (_variableTimerPaused!=null){_parent.DeregisterBool(_variableTimerPaused);}
			if (_incrementCounter!=null){_parent.DeregisterAction(_incrementCounter);}
			if (_decrementCounter!=null){_parent.DeregisterAction(_decrementCounter);}
			if (_resetCounter!=null){_parent.DeregisterAction(_resetCounter);}
			_paramA.DeregisterVarParam();
			_paramB.DeregisterVarParam();
		}
		public void CopyVariableFrom(VUMLVariable vumlVariable, bool updateID =true){
			if (updateID){_variableID=vumlVariable._variableID;_varLabel=vumlVariable._varLabel;}
			_variableType = vumlVariable._variableType;
			_paramCount = vumlVariable._paramCount;
			_operationType.val = vumlVariable._operationType.val;
			_operation.val = vumlVariable._operation.val;
			_calcFrequency.val = vumlVariable._calcFrequency.val;
			_variableBoolResult.val = vumlVariable._variableBoolResult.val;
			_variableFloatResult.val = vumlVariable._variableFloatResult.val;
			_variableStringResult.val = vumlVariable._variableStringResult.val;	
			_notes.val = vumlVariable._notes.val;
			_lookAtFOV.val =vumlVariable._lookAtFOV.val;
			_variableTimerPaused.val = vumlVariable._variableTimerPaused.val;
			_paramA.CopyParamFrom(vumlVariable._paramA);_paramB.CopyParamFrom(vumlVariable._paramB);
			if (_variableID!=0){RemoveCollider();SetupCollider();}
		}
		public void RestoreFromJSON(string varLabel, JSONNode varSaveJSON){			
			if (varSaveJSON[varLabel+"OperationType"]!=null){_operationType.val = varSaveJSON[varLabel+"OperationType"].Value;}	
			if (varSaveJSON[varLabel+"Operation"]!=null){_operation.val = varSaveJSON[varLabel+"Operation"].Value;}
			if (varSaveJSON[varLabel+"CalcFrequency"]!=null){_calcFrequency.val = varSaveJSON[varLabel+"CalcFrequency"].Value;	}
			if (varSaveJSON[varLabel+"Result"]!=null){
				if(_variableType=="BOOL"){_variableBoolResult.val = varSaveJSON[varLabel+"Result"].AsBool;}
				if(_variableType=="FLOAT"){_variableFloatResult.val = varSaveJSON[varLabel+"Result"].AsFloat;}
				if(_variableType=="STRING"){_variableStringResult.val = varSaveJSON[varLabel+"Result"].Value;}
			}
			if (varSaveJSON[varLabel+"Notes"]!=null){_notes.val = varSaveJSON[varLabel+"Notes"].Value;}
			if (varSaveJSON[varLabel+"LookAtFOV"]!=null){_lookAtFOV.val=varSaveJSON[varLabel+"LookAtFOV"].AsFloat;}
			if (varSaveJSON[varLabel+"TimerPaused"]!=null){_variableTimerPaused.val = varSaveJSON[varLabel+"TimerPaused"].AsBool;	}
			_paramCount =GetParamCount();		
			_paramA.RestoreFromJSON(varLabel,"A",varSaveJSON);
			_paramB.RestoreFromJSON(varLabel,"B",varSaveJSON);
			if (_variableID!=0){RemoveCollider();SetupCollider();}
		}
        private int GetParamCount(){
			int paramCount =0;
			if (_operationType.val=="Dynamic" || _operationType.val=="Substring" || _operationType.val =="Look At"|| _operationType.val =="Float As String"|| _operationType.val =="Bool As String" || (_operationType.val=="Maths" && _operation.val!="+" && _operation.val!="-" && _operation.val!="*" && _operation.val!="/" && _operation.val!="^" && _operation.val!="MAX" && _operation.val!="MIN" && _operation.val!="LOG" && _operation.val!="ATAN2")){paramCount = 1;}
			else if (_operationType.val!="Static" && _operationType.val!="Timer"&& _operationType.val!="Counter"){paramCount =2;}
			return(paramCount);
		}
		public void CloseAllPopup(UIDynamicPopup exception){
            if (_operationTypePopup != null && _operationTypePopup != exception) { _operationTypePopup.popup.visible = false; }
            if (_operationPopup != null && _operationPopup != exception) { _operationPopup.popup.visible = false; }
			if (_calcFrequencyPopup != null && _calcFrequencyPopup != exception) { _calcFrequencyPopup.popup.visible = false; }
			if (_paramA != null){_paramA.CloseAllPopup(exception); }
			if (_paramB != null){_paramB.CloseAllPopup(exception); }
        }
        public void DisableUpdates(bool disableState){_disableUIUpdates = disableState; _paramA._disableUIUpdates = disableState; _paramB._disableUIUpdates = disableState;}
		public void SyncOperationTypeChoices (){
			VUML.CloseAllPopup(_operationTypePopup);
			List<string> opTypeChoices = new List<string>();
			if (_variableType == "BOOL" || _variableType == "FLOAT"|| _variableType == "STRING"){opTypeChoices.Add("Static");opTypeChoices.Add("Dynamic");}
			if (_variableType == "BOOL"){opTypeChoices.Add("Boolean Logic");opTypeChoices.Add("Float Comparison");opTypeChoices.Add("String Comparison");opTypeChoices.Add("Look At");opTypeChoices.Add("Collision");}
			else if (_variableType == "FLOAT"){opTypeChoices.Add("Maths");	opTypeChoices.Add("Distance");opTypeChoices.Add("Timer"); opTypeChoices.Add("Counter");	}
			else if (_variableType == "STRING"){opTypeChoices.Add("Concatenation");opTypeChoices.Add("Float As String");opTypeChoices.Add("Bool As String");}
			_operationType.choices = new List<string>();;
			_operationType.choices = opTypeChoices;
		}
		public void SyncOperationChoices (){
			VUML.CloseAllPopup(_operationPopup);
			List<string> opChoices = new List<string>();
			if(_operationType.val == "Maths"){
				opChoices.Add("+");opChoices.Add("-");opChoices.Add("*");opChoices.Add("/");opChoices.Add("^");opChoices.Add("MAX");opChoices.Add("MIN");
				opChoices.Add("ABS");
				opChoices.Add("ROUND");
				opChoices.Add("SIGN");
				opChoices.Add("EXP");
				opChoices.Add("LOG");
				opChoices.Add("LOGE");
				opChoices.Add("SIN");
				opChoices.Add("COS");
				opChoices.Add("TAN");
				opChoices.Add("SINH");
				opChoices.Add("COSH");
				opChoices.Add("TANH");
				opChoices.Add("ASIN");
				opChoices.Add("ACOS");
				opChoices.Add("ATAN");
				opChoices.Add("ATAN2");						
			}
			else if (_operationType.val == "Timer"){
				opChoices.Add("Freezable & Scalable");opChoices.Add("Freezable");opChoices.Add("Scalable");opChoices.Add("No Freeze or Scale");
			}
			else if (_operationType.val == "Boolean Logic"){
				opChoices.Add("AND");opChoices.Add("OR");opChoices.Add("XOR");opChoices.Add("NAND");opChoices.Add("NOR");			
			}
			else if (_operationType.val == "Float Comparison"){opChoices.Add("==");opChoices.Add("!=");opChoices.Add("<");opChoices.Add("<=");opChoices.Add(">");opChoices.Add(">=");}
			else if (_operationType.val == "String Comparison"){
				opChoices.Add("==");opChoices.Add("!=");opChoices.Add("Contains");				
			}
			_operation.choices = new List<string>();_operation.choices = opChoices;
		}
		public void SyncCalcFreqChoices (){
			VUML.CloseAllPopup(_calcFrequencyPopup);
			List<string> calcFreqChoices = new List<String>();
			calcFreqChoices.Add("Continuous");
			calcFreqChoices.Add("On Execution");
			_calcFrequency.choices = new List<string>();_calcFrequency.choices = calcFreqChoices;
		}		
		public void ClearTextValue (){_variableStringResult.val="";}
		public void SelectOperationType (string operationType){
			try {
				if (!_disableUIUpdates) {
					if (operationType=="Static" || operationType=="Timer"|| operationType=="Counter"){_calcFrequency.val="Continuous";}
					string defaultAtom ="";SyncOperationChoices();
					if(_operation.choices.Count >0 && !_operation.choices.Contains(_operation.val)){_operation.val=_operation.choices[0];}					
					if (_operationType.val =="Distance" || _operationType.val =="Look At" ){defaultAtom=_parent.containingAtom.name+">";}
					else if ( _operationType.val =="Collision"){
						if (_parent.containingAtom.type=="CollisionTrigger" || _parent.containingAtom.type =="Person"){
							defaultAtom=_parent.containingAtom.name+">";}
						else {defaultAtom="NONE";}
					}
					else {defaultAtom="LOCAL VUML";}
					_paramA.ResetDefaults(defaultAtom);
					if (_operationType.val =="Collision"){defaultAtom=_parent.containingAtom.name+">";}
					_paramB.ResetDefaults(defaultAtom);
					initVariableUI();
					_parent.SaveUIVariable(); 
				}
			}catch (Exception e) {SuperController.LogError("Exception caught in "+_parent.containingAtom.name+" "+_parent.storeId+": " + e);}
		}
		public void SelectCalcFrequency (string calcFequency){
			if (!_disableUIUpdates) {initVariableUI();_parent.SaveUIVariable(); } 
		}
		public void SelectOperation (string operation){
			try {				
				if (!_disableUIUpdates) {
					if(_operationType.val=="Timer"){
						VUMLVariable tempVar = _parent._vumlVariableDict[_parent._currentVariableChooser.val];
						tempVar._timerStartTime=0f;tempVar._pauseTimerStart=0f;tempVar._freezeTimeStart=0f;}
					initVariableUI();
					_paramA.SyncAtomChoices();
					if(!_paramA._atomName.choices.Contains(_paramA._atomName.val)){_paramA._atomName.val=_paramA._atomName.choices[0];}
					_parent.SaveUIVariable();					
				}
			}catch (Exception e) {SuperController.LogError("Exception caught in "+_parent.containingAtom.name+" "+_parent.storeId+": " + e);}		}
		public void SelectStaticBoolValue (bool boolValue){ if (!_disableUIUpdates) { _parent.SaveUIVariable(); } }
		public void SelectStaticFloatValue (float floatValue){ if (!_disableUIUpdates) { _parent.SaveUIVariable(); } }				
        public void initVariableUI(){
            VUML parentMVR = _parent;
            if (_operationTypePopup != null) { parentMVR.RemovePopup(_operationTypePopup); }
            if (_operationPopup != null) { parentMVR.RemovePopup(_operationPopup); }
			if (_calcFrequencyPopup != null) { parentMVR.RemovePopup(_calcFrequencyPopup); }
			if (_boolResultToggle != null) { parentMVR.RemoveToggle(_boolResultToggle); }
			if (_stringResultTextField != null) { parentMVR.RemoveTextField(_stringResultTextField); }
			if (_notesTextField != null) { parentMVR.RemoveTextField(_notesTextField); }
			if (_floatResultSlider != null) { parentMVR.RemoveSlider(_floatResultSlider); }
			if (_exectuteOperationButton != null) { parentMVR.RemoveButton(_exectuteOperationButton); }
			if (_clearStringButton != null) { parentMVR.RemoveButton(_clearStringButton); }
			if (_deleteButton != null) { parentMVR.RemoveButton(_deleteButton); }
			if (_resetTimerButton != null) { parentMVR.RemoveButton(_resetTimerButton); }
			if (_incrementCounterButton != null) { parentMVR.RemoveButton(_incrementCounterButton); }
			if (_decrementCounterButton != null) { parentMVR.RemoveButton(_decrementCounterButton); }
			if (_resetCounterButton != null) { parentMVR.RemoveButton(_resetCounterButton); }
			if (_timerPausedToggle != null) { parentMVR.RemoveToggle(_timerPausedToggle); }
			if (_lookAtFOVSlider !=null){parentMVR.RemoveSlider(_lookAtFOVSlider);}		
			if (_displaySpacer != null) { parentMVR.RemoveSpacer(_displaySpacer); }
			_paramA.clearUI();_paramB.clearUI();		
			if (_parent._currentVariableChooser.val !="NONE"){
				_operationTypePopup = parentMVR.CreateSetupScrollablePopup(_operationType,true,480f,this.SyncOperationTypeChoices,"Operation Type");
				_operationTypePopup.popup.onValueChangeHandlers += SelectOperationType;			
				if(_operationType.val == "Static") {
					if (_variableType=="BOOL"){
						_boolResultToggle = parentMVR.CreateToggle(_variableBoolResult,true);						
						_boolResultToggle.label = "Boolean Value";
						_boolResultToggle.toggle.onValueChanged.AddListener((bool val) => { this.SelectStaticBoolValue(val); });
					}
					else if (_variableType=="FLOAT"){
						_floatResultSlider = parentMVR.CreateSlider(_variableFloatResult,true);						
						_floatResultSlider.label = "Float Value";
						_floatResultSlider.slider.onValueChanged.AddListener((float val) => { this.SelectStaticFloatValue(val); });
					}
					else if (_variableType=="STRING"){
						_stringResultTextField = parentMVR.CreateTextInput(_variableStringResult,true);
						_clearStringButton = parentMVR.CreateButton("Clear Text",true);
						_clearStringButton.button.onClick.AddListener(() => { ClearTextValue(); });
					}				
				}
				if (_operationType.val =="Boolean Logic" || _operationType.val =="Float Comparison" || _operationType.val =="String Comparison" ||_operationType.val =="Maths" ||_operationType.val =="Timer" ){
					_operationPopup = parentMVR.CreateSetupScrollablePopup(_operation,true,460f,this.SyncOperationChoices,"Operation");
					_operationPopup.popup.onValueChangeHandlers += SelectOperation;
				}
				if (_operationType.val!="Static"&& _operationType.val!="Timer"&& _operationType.val!="Counter"){
					_calcFrequencyPopup = parentMVR.CreateSetupScrollablePopup(_calcFrequency,true,180f,SyncCalcFreqChoices,"Result Update Frequency");
					_calcFrequencyPopup.popup.onValueChangeHandlers += SelectCalcFrequency;
				}
				if (_operationType.val=="Look At"){
					_lookAtFOVSlider = parentMVR.CreateSlider(_lookAtFOV,true);						
					_lookAtFOVSlider.label = "Look At FOV (degrees)";
					_lookAtFOVSlider.slider.onValueChanged.AddListener((float val) => { _parent.SaveUIVariable(); });
				}
				if (_calcFrequency.val =="On Execution"){
					_exectuteOperationButton = parentMVR.CreateButton("Execute Update",true);
					_exectuteOperationButton.button.onClick.AddListener(() => { UpdateResult();_parent.SaveUIVariable(); });
					_exectuteOperationButton.buttonColor = Color.green;
				}
				string paramsType ="";
				_paramCount =GetParamCount();
				if (_paramCount>0){_paramA.initVarParamUI();}
				if (_paramCount>1){_paramB.initVarParamUI();}
				if (_variableType=="FLOAT"&&_operationType.val=="Timer"){
					_timerPausedToggle = parentMVR.CreateToggle(_variableTimerPaused,true); _timerPausedToggle.label="Timer Paused";
					_timerPausedToggle.toggle.onValueChanged.AddListener((bool val)=>{if (!_disableUIUpdates) { parentMVR.SaveUIVariable(); }});
					_resetTimerButton= parentMVR.CreateButton("Reset Timer",true);
					_resetTimerButton.button.onClick.AddListener(() => { ResetTimer(); });				
				}				
				if (_variableType=="FLOAT"&&_operationType.val=="Counter"){
					_incrementCounterButton= parentMVR.CreateButton("Increment Counter",true);
					_incrementCounterButton.button.onClick.AddListener(() => { UpdateCounter("Increment"); });
					_decrementCounterButton= parentMVR.CreateButton("Decrement Counter",true);
					_decrementCounterButton.button.onClick.AddListener(() => { UpdateCounter("Decrement"); });	
					_resetCounterButton= parentMVR.CreateButton("Reset Counter",true);
					_resetCounterButton.button.onClick.AddListener(() => { UpdateCounter("Reset"); });				
				}	
				int varTypeCount =0;
				if (_variableType=="BOOL"){varTypeCount=_parent._boolCountInt;}
				if (_variableType=="FLOAT"){varTypeCount=_parent._floatCountInt;}
				if (_variableType=="STRING"){varTypeCount=_parent._stringCountInt;}				
				if (_parent._currentVariableChooser.val == "v"+_variableType+varTypeCount.ToString()){
					_deleteButton= parentMVR.CreateButton("Delete "+_parent._currentVariableChooser.val,true);
					_deleteButton.buttonColor = Color.red;_deleteButton.textColor = Color.white;
					_deleteButton.button.onClick.AddListener(() => { _parent.DeleteVariable(); });
				}
				_notesTextField = parentMVR.CreateTextInput(_notes,true);_notesTextField.height =300;
			}				
			_displaySpacer = parentMVR.CreateSpacer(true); _displaySpacer.height = 500;
        }	
		public void ResetTimer (){
			VUMLVariable tempVar ;
			if (_variableID == 0) {tempVar= _parent._vumlVariableDict[_parent._currentVariableChooser.val];}
			else {tempVar = this;}
			tempVar._timerStartTime=0f;tempVar._pauseTimerStart=0f;tempVar._freezeTimeStart=0f;
		}
		public void UpdateCounter (string action){
			VUMLVariable tempVar ;
			if (_variableID == 0) {tempVar= _parent._vumlVariableDict[_parent._currentVariableChooser.val];}
			else {tempVar = this;}
			if (action=="Increment"){tempVar._variableFloatResult.val = tempVar._variableFloatResult.val+1f;}
			if (action=="Decrement"){tempVar._variableFloatResult.val = tempVar._variableFloatResult.val-1f;}
			if (action=="Reset"){tempVar._variableFloatResult.val = 0f;}
		}
		public Vector3 GetNodePosition(Atom atom, string nodeName){
			Vector3 nodePosition = new Vector3();	
			foreach (FreeControllerV3 fc in atom.freeControllers){ 
				if (fc.name=="control" && nodeName=="control"){nodePosition=fc.transform.position;}
				else if (atom.type == "Person" && fc.name==nodeName+"Control"){nodePosition=fc.followWhenOff.position;}
				else if (fc.name==nodeName){nodePosition=fc.transform.position;}
			}
			foreach (Rigidbody rb in atom.realRigidbodies){
				if (atom.type == "Person" ){if (rb.name==nodeName && nodeName.Contains("Trigger")){nodePosition=rb.transform.position;}}
				else if (rb.name==nodeName){nodePosition=rb.transform.position;}
			}
			return (nodePosition);
		}
		public void SetupCollider(){
			if (_paramA._paramType.val == "COLLIDER" ){
				string targetName = _paramA._targetName.val;if (targetName=="NONE"){targetName="object";}
				Rigidbody colliderRB = _paramA.GetParamAtom()?.rigidbodies?.First(rb => rb.name == targetName);
				if (colliderRB!=null){_collider = colliderRB.gameObject.AddComponent<TriggerCollide>();_collider.OnCollide += this.ColliderContact; _collidedRBs = new List<Rigidbody>();_collidedVRRBNames = new List<string>(); _collideActive = false;	}
			}
		}
		public void RemoveCollider(){VUML.Destroy (_collider);}
		public Atom GetAtomByRB(Rigidbody colliderRB){
			foreach (Atom atom in SuperController.singleton.GetAtoms()){
				foreach (Rigidbody atomRB in atom.rigidbodies){
					if (colliderRB.GetInstanceID()==atomRB.GetInstanceID() || colliderRB.transform.IsChildOf(atomRB.transform)){return(atom);}
				}
			}
			return (null);
		}
		public Rigidbody GetAtomRBByRB(Rigidbody colliderRB){
			List<Rigidbody> parentRBs = new List<Rigidbody>();
			foreach (Atom atom in SuperController.singleton.GetAtoms()){
				foreach (Rigidbody atomRB in atom.rigidbodies){
					if (colliderRB.GetInstanceID()==atomRB.GetInstanceID()&&SuperController.singleton.GetRigidbodyNamesInAtom(atom.name).Contains(atomRB.name)&&  (atomRB.name.Length <7 || atomRB.name.Substring(atomRB.name.Length-7,7) !="Control") && (atomRB.name.Length <4 ||atomRB.name.Substring(0,4) !="hair")){return(atomRB);}
					else if (colliderRB.transform.IsChildOf(atomRB.transform)&&SuperController.singleton.GetRigidbodyNamesInAtom(atom.name).Contains(atomRB.name) &&  (atomRB.name.Length <7 || atomRB.name.Substring(atomRB.name.Length-7,7) !="Control") && (atomRB.name.Length <4 ||atomRB.name.Substring(0,4) !="hair")){parentRBs.Add(atomRB);}
				}
			}
			foreach (Rigidbody parentAtomRB in parentRBs){
				int count =0;
				foreach (Rigidbody innerParentAtomRB in parentRBs){if (parentAtomRB.transform.IsChildOf(innerParentAtomRB.transform)){count++;}}
				if (count==parentRBs.Count){return(parentAtomRB);}
			}
			return (null);
		}		
		public void ColliderContact(object sender, TriggerEventArgs eventArgs ){
			try{
				bool leftVRHand = ((_paramB._atomName.val== "Left VR Hand" || _paramB._atomName.val== "Either VR Hand" || _paramB._atomName.val== "Any") && eventArgs.collider.attachedRigidbody.name.Length >=8 && eventArgs.collider.attachedRigidbody.name.Substring(0,8)=="L_Finger");
				bool rightVRHand = ((_paramB._atomName.val== "Right VR Hand" || _paramB._atomName.val== "Either VR Hand" || _paramB._atomName.val== "Any") && eventArgs.collider.attachedRigidbody.name.Length >=8 && eventArgs.collider.attachedRigidbody.name.Substring(0,8)=="R_Finger");
				
				if (leftVRHand || rightVRHand){
					if (eventArgs.evtType == "Enter"){if (!_collidedVRRBNames.Contains(eventArgs.collider.attachedRigidbody.name)){_collidedVRRBNames.Add(eventArgs.collider.attachedRigidbody.name);}}
					else {_collidedVRRBNames.Remove(eventArgs.collider.attachedRigidbody.name);}
					if (_collidedVRRBNames.Count>0){_collideActive = true;}if (_collidedVRRBNames.Count==0){_collideActive = false;}
				}
				else {
					Atom colliderAtom = GetAtomByRB(eventArgs.collider.attachedRigidbody);
					Rigidbody colliderRB = null;

					if (colliderAtom!=null){ colliderRB = GetAtomRBByRB(eventArgs.collider.attachedRigidbody);}
					if (colliderRB!=null){ 
						
						if (_paramB._atomName.val == "Any" || (_paramB.GetParamAtom()!=null && _paramB.GetParamAtom().name == colliderAtom.name)){
							if (_paramB._atomName.val == "Any" || _paramB._targetName.val == "Any Node" || _paramB._targetName.val == "NONE" || _paramB._targetName.val == colliderRB.name){
								if (eventArgs.evtType == "Enter"){if (!_collidedRBs.Contains(colliderRB)){_collidedRBs.Add(colliderRB);}}
								else {_collidedRBs.Remove(colliderRB);}
							}				
						}
					}
					if (_collidedRBs.Count>0){_collideActive = true;}if (_collidedRBs.Count==0){_collideActive = false;}
				}				
			}catch (Exception e) { SuperController.LogError("Exception caught: " + e); }	
		}
		public void UpdateResult(){
			try {			
				if (_paramCount >0 && !_paramA.IsValidParam()){
					if(_paramA._targetName.val!="NONE"){SuperController.LogMessage(_parent.containingAtom.name+":"+_varLabel+": The selected Target for parameter A of the VUML operation could not be found.");_calcFrequency.val = "On Execution";VUML._uiVariable.initVariableUI();}
					_variableBoolResult.val = false;_variableStringResult.val="";_variableFloatResult.val=0f;					
				}
				else if (_paramCount >1 && !_paramB.IsValidParam()){
					if(_paramB._targetName.val!="NONE"){SuperController.LogMessage(_parent.containingAtom.name+":"+_varLabel+": The selected Target for parameter B of the VUML operation could not be found.");_calcFrequency.val = "On Execution";VUML._uiVariable.initVariableUI();}
					_variableBoolResult.val = false;_variableStringResult.val="";_variableFloatResult.val=0f;
				}
				else {				
					if (_variableType== "BOOL"){
						if (_operationType.val=="Dynamic"){_variableBoolResult.val = _paramA.GetBoolResult();}
						else if (_operationType.val=="Boolean Logic"){
							if (_operation.val =="AND"){_variableBoolResult.val = _paramA.GetBoolResult() && _paramB.GetBoolResult();}
							if (_operation.val =="OR"){_variableBoolResult.val = _paramA.GetBoolResult() || _paramB.GetBoolResult();}
							if (_operation.val =="XOR"){_variableBoolResult.val = (_paramA.GetBoolResult() || _paramB.GetBoolResult()) && !(_paramA.GetBoolResult() && _paramB.GetBoolResult());}
							if (_operation.val =="NAND"){_variableBoolResult.val = !(_paramA.GetBoolResult() && _paramB.GetBoolResult());}
							if (_operation.val =="NOR"){_variableBoolResult.val = !(_paramA.GetBoolResult() || _paramB.GetBoolResult());}
						}
						else if (_operationType.val=="Float Comparison"){		
							float paramA = _paramA.GetFloatResult();float paramB = _paramB.GetFloatResult();
							if (_operation.val =="<"){_variableBoolResult.val = paramA < paramB;}
							if (_operation.val =="<="){_variableBoolResult.val = paramA <= paramB;}
							if (_operation.val ==">"){_variableBoolResult.val = paramA > paramB;}
							if (_operation.val ==">="){_variableBoolResult.val = paramA >= paramB;}
							if (_operation.val =="=="){_variableBoolResult.val = paramA == paramB;}
							if (_operation.val =="!="){_variableBoolResult.val = paramA != paramB;}
						}
						else if (_operationType.val=="String Comparison"){			
							string paramA =_paramA.GetStringResult();string paramB =_paramB.GetStringResult();				
							if (_operation.val =="=="){_variableBoolResult.val = paramA == paramB;}
							if (_operation.val =="!="){_variableBoolResult.val = paramA != paramB;}
							if (_operation.val =="Contains"){_variableBoolResult.val = paramA.Contains(paramB);}
						}
						else if (_operationType.val=="Look At" ){
							Vector3 paramAPosition = _paramA.GetNodePosition();
							Transform playerHeadTransform = CameraTarget.centerTarget.transform;
							Vector3 playerLookingVector = playerHeadTransform.forward;
							Vector3 directionToTarget = paramAPosition - playerHeadTransform.position;
							float angle = Vector3.Angle(playerLookingVector,directionToTarget);
							_variableBoolResult.val = angle<=(_lookAtFOV.val/2f);
						}
						else if (_operationType.val=="Collision"){_variableBoolResult.val = _collideActive ;}
						else if (_operationType.val!="Static"){_variableBoolResult.val = false;}
					}
					else if (_variableType== "FLOAT"){
						if (_operationType.val=="Dynamic"){_variableFloatResult.val = _paramA.GetFloatResult();}
						else if (_operationType.val=="Maths"){
							float paramA = _paramA.GetFloatResult();float paramB = _paramB.GetFloatResult();
							if (_operation.val =="+"){_variableFloatResult.val = paramA + paramB;}
							if (_operation.val =="-"){_variableFloatResult.val = paramA - paramB;}
							if (_operation.val =="/"){_variableFloatResult.val = paramA / paramB;}
							if (_operation.val =="*"){_variableFloatResult.val = paramA * paramB;}
							if (_operation.val =="^"){_variableFloatResult.val = Mathf.Pow (paramA, paramB);}
							if (_operation.val =="MAX"){_variableFloatResult.val =Mathf.Max (paramA, paramB);}
							if (_operation.val =="MIN"){_variableFloatResult.val = Mathf.Min(paramA, paramB);}
							if (_operation.val =="ABS"){_variableFloatResult.val = (float) Math.Abs(paramA);}
							if (_operation.val =="ROUND"){_variableFloatResult.val = (float) Math.Round(paramA);}
							if (_operation.val =="SIGN"){_variableFloatResult.val = (float) Math.Sign(paramA);}
							if (_operation.val =="EXP"){_variableFloatResult.val = (float) Math.Exp(paramA);}
							if (_operation.val =="LOG"){_variableFloatResult.val = (float) Math.Log(paramA,paramB);}
							if (_operation.val =="LOGE"){_variableFloatResult.val = (float) Math.Log(paramA);}
							if (_operation.val =="SIN"){_variableFloatResult.val = (float) Math.Sin(paramA);}
							if (_operation.val =="COS"){_variableFloatResult.val = (float) Math.Cos(paramA);}
							if (_operation.val =="TAN"){_variableFloatResult.val = (float) Math.Tan(paramA);}
							if (_operation.val =="SINH"){_variableFloatResult.val = (float) Math.Sinh(paramA);}
							if (_operation.val =="COSH"){_variableFloatResult.val = (float) Math.Cosh(paramA);}
							if (_operation.val =="TANH"){_variableFloatResult.val = (float) Math.Tanh(paramA);}
							if (_operation.val =="ASIN"){_variableFloatResult.val = (float) Math.Asin(paramA);}
							if (_operation.val =="ACOS"){_variableFloatResult.val = (float) Math.Acos(paramA);}
							if (_operation.val =="ATAN"){_variableFloatResult.val = (float) Math.Atan(paramA);}
							if (_operation.val =="ATAN2"){_variableFloatResult.val = (float) Math.Atan2(paramA,paramB);}
						}
						else if (_operationType.val=="Distance"){
							Vector3 paramAPosition = _paramA.GetNodePosition() ;
							Vector3 paramBPosition = _paramB.GetNodePosition();
							_variableFloatResult.val = Vector3.Distance(paramAPosition,paramBPosition);
						}
						else if (_operationType.val=="Timer"){
							bool freezable = (_operation.val=="Freezable & Scalable"||_operation.val=="Freezable");
							if (_timerStartTime == 0f){_timerStartTime=GetTimeNow();}
							if (_variableTimerPaused.val && _pauseTimerStart == 0f){_pauseTimerStart=GetTimeNow();}	
							if (SuperController.singleton.freezeAnimation && _freezeTimeStart ==0f && freezable){_freezeTimeStart=GetTimeNow();}					
							if (_pauseTimerStart >0f && _freezeTimeStart >0f ) {
								if (_pauseTimerStart > _freezeTimeStart){_pauseTimerStart = _freezeTimeStart;}
								else {_freezeTimeStart = _pauseTimerStart;}
							}					
							if (!_variableTimerPaused.val && _pauseTimerStart > 0f){
								if (!SuperController.singleton.freezeAnimation || !freezable){_timerStartTime=_timerStartTime+(GetTimeNow()-_pauseTimerStart);}
								_pauseTimerStart=0f;
							}
							if (!SuperController.singleton.freezeAnimation && _freezeTimeStart > 0f){
								if (!_variableTimerPaused.val){_timerStartTime=_timerStartTime+(GetTimeNow()-_freezeTimeStart);}
								_freezeTimeStart=0f;
							}						
							if ((!SuperController.singleton.freezeAnimation || !freezable) && !_variableTimerPaused.val){_variableFloatResult.val = GetTimeNow() - _timerStartTime;}
							else if (SuperController.singleton.freezeAnimation && !_variableTimerPaused.val){_variableFloatResult.val = _freezeTimeStart - _timerStartTime;}
							else if ((!SuperController.singleton.freezeAnimation || !freezable) && _variableTimerPaused.val){_variableFloatResult.val = _pauseTimerStart - _timerStartTime;}
							else if (SuperController.singleton.freezeAnimation && _variableTimerPaused.val){_variableFloatResult.val = Mathf.Min(_pauseTimerStart,_freezeTimeStart) - _timerStartTime;}			
						}
						else if (_operationType.val=="Counter"){ _variableFloatResult.val = Mathf.Round( _variableFloatResult.val);}
					}
					else if(_variableType== "STRING"){
						if (_operationType.val=="Dynamic"){_variableStringResult.val = _paramA.GetStringResult();}
						else if (_operationType.val=="Concatenation"){_variableStringResult.val = _paramA.GetStringResult()+_paramB.GetStringResult();}
						else if (_operationType.val=="Float As String"){_variableStringResult.val = _paramA.GetFloatResult().ToString();}
						else if (_operationType.val=="Bool As String"){_variableStringResult.val = _paramA.GetBoolResult().ToString();}
					}
				}

			}catch (Exception e) {SuperController.LogError("Exception caught: " + e);}
		}
		protected float GetTimeNow (){float time=0f ; if (_operation.val =="No Freeze or Scale" || _operation.val =="Freezable") { time = Time.unscaledTime ; } else { time = Time.time ; }return (time);}	
        public string _variableType; public int _variableID ;public int _paramCount=0;public string _varLabel ;public bool _disableUIUpdates = false;public float _timerStartTime = 0f;public float _freezeTimeStart = 0f;public float _pauseTimerStart = 0f;	
		public VariableParam _paramA ;public VariableParam _paramB ;public VUML _parent;		
		public JSONStorableStringChooser _operationType ;public JSONStorableStringChooser _operation ;public JSONStorableStringChooser _calcFrequency ;public JSONStorableAction _exectuteOperation;public JSONStorableAction _resetTimer;public JSONStorableAction _incrementCounter;public JSONStorableAction _decrementCounter;public JSONStorableAction _resetCounter;public JSONStorableBool _variableBoolResult;public JSONStorableBool _variableTimerPaused ;public JSONStorableFloat _variableFloatResult;public JSONStorableString _variableStringResult;public JSONStorableFloat _lookAtFOV;public JSONStorableString _notes;	public UIDynamicPopup _operationTypePopup ;public UIDynamicPopup _operationPopup ;public UIDynamicPopup _calcFrequencyPopup ;public UIDynamicButton _exectuteOperationButton;public UIDynamicTextField _stringResultTextField;public UIDynamicTextField _notesTextField;public UIDynamicToggle _boolResultToggle;public UIDynamicToggle _timerPausedToggle;public UIDynamicSlider _floatResultSlider;public UIDynamicSlider _lookAtFOVSlider;public UIDynamicButton _clearStringButton;public UIDynamicButton _deleteButton;public UIDynamicButton _resetTimerButton; public UIDynamicButton _incrementCounterButton;public UIDynamicButton _decrementCounterButton;public UIDynamicButton _resetCounterButton;	 public UIDynamic _displaySpacer;protected TriggerCollide _collider; protected List<Rigidbody> _collidedRBs ;protected List<string> _collidedVRRBNames ; protected bool _collideActive = false;
    }	
    public class VariableParam {
        public static Dictionary<string, string> MAPAtomTypeToDefaultReceiver = new Dictionary<string, string>()
        {{"Animation","AnimationPattern" },{"Sound","AudioSource" },{"Force","ForceProducer" },{"Light","Light" },{"Reflective","MirrorRender" },{"Triggers","Trigger" }};
        public VariableParam(string varType,int varID, string AorB, string varLabel, VUMLVariable parentVar) {
            _paramType = new JSONStorableString(varLabel + AorB + "TypeName", "");
			_paramType.storeType = JSONStorableParam.StoreType.Full;		
            _atomName = new JSONStorableStringChooser(varLabel + AorB + "AtomName", null, "LOCAL VUML", ""); _atomName.storeType = JSONStorableParam.StoreType.Full;
            _atomType = new JSONStorableString(varLabel + AorB + "AtomType", "");_atomType.storeType = JSONStorableParam.StoreType.Full;
            _receiverGroupName = new JSONStorableStringChooser(varLabel + AorB + "ReceiverGroupName", null, "", "");_receiverGroupName.storeType = JSONStorableParam.StoreType.Full;
            _receiverName = new JSONStorableStringChooser(varLabel + AorB + "ReceiverName", null, "", "");_receiverName.storeType = JSONStorableParam.StoreType.Full;
            _targetName = new JSONStorableStringChooser(varLabel + AorB + "TargetName", null, "", "");_targetName.storeType = JSONStorableParam.StoreType.Full;		
			_invertBool = new JSONStorableBool (varLabel +  AorB + "InvertBool", false);
			_invertBool.storeType = JSONStorableParam.StoreType.Full;
			_staticBoolValue = new JSONStorableBool(varLabel +  AorB +"StaticBoolValue",false,changedBool =>{bool temp = changedBool ;if(!_disableUIUpdates){_parentVar._parent.SaveUIVariable();}});_staticBoolValue.storeType = JSONStorableParam.StoreType.Full;
			_staticStringValue = new JSONStorableString(varLabel +  AorB +"StaticStringValue","",changedText =>{string temp = changedText ;if(!_disableUIUpdates){_parentVar._parent.SaveUIVariable();}});_staticStringValue.storeType = JSONStorableParam.StoreType.Full;
			_staticFloatValue = new JSONStorableFloat(varLabel +  AorB +"StaticFloatValue",0f,changedFloat =>{float temp = changedFloat ;if(!_disableUIUpdates){_parentVar._parent.SaveUIVariable();}},-10000f,10000f,false);_staticFloatValue.storeType = JSONStorableParam.StoreType.Full;
			if (AorB=="B"){_isBParam=true;}else{_isBParam=false;}
			_parentVar = parentVar;
        }
        public void ResetDefaults(string atomName){
			_atomName.val = atomName;
			_paramType.val="";
			Atom atom = GetParamAtom();
			if (atom!=null){_atomType.val = atom.type;}
			else {_atomType.val = "NONE";}
			if (_parentVar._operationType.val=="Dynamic" || _parentVar._operationType.val=="Boolean Logic" || _parentVar._operationType.val=="Maths" || _parentVar._operationType.val=="Concatenation" || _parentVar._operationType.val=="Substring"){_paramType.val = _parentVar._variableType ;}
			else if (_parentVar._operationType.val=="String Comparison"){_paramType.val = "STRING";}
			else if (_parentVar._operationType.val=="Float Comparison"||_parentVar._operationType.val=="Float As String"){_paramType.val = "FLOAT";}
			else if (_parentVar._operationType.val=="Bool As String"){_paramType.val = "BOOL";}
			else if (_parentVar._operationType.val=="Look At"  || _parentVar._operationType.val=="Distance"){_paramType.val = "NODE";}
			else if (_parentVar._operationType.val=="Collision" && _isBParam){_paramType.val = "RB";}
			else if (_parentVar._operationType.val=="Collision" && !_isBParam){_paramType.val = "COLLIDER";}
			ResetReceiverName(false);
		}
        public void ResetReceiverName(bool updateUI) {
            string atomCategory = GetParamAtomCategory();
            if (atomCategory == "People"){SyncReceiverGroupChoices();if (!_receiverGroupName.choices.Contains(_receiverGroupName.val)){ _receiverGroupName.val = "Other";} }
            SyncReceiverChoices();
			if (_atomName.val=="LOCAL VUML"){
				_receiverName.val = _parentVar._parent.storeId;
			}
			else{
				if ( !_receiverName.choices.Contains(_receiverName.val)){
					if (atomCategory == "People") {
						_receiverName.val = _receiverName.choices[0];
					}
					else {
						string defaultReceiver = null;
						MAPAtomTypeToDefaultReceiver.TryGetValue(GetParamAtomCategory(), out defaultReceiver);
						if (defaultReceiver == null) { _receiverName.val = _receiverName.choices[0]; } else { _receiverName.val = defaultReceiver; }
					}
				}
			}
            ResetTargetName(false);
            if (updateUI) { _parentVar.initVariableUI(); }
        }
        public void ResetTargetName(bool updateUI){
            SyncTargetChoices();
            if (!_targetName.choices.Contains(_targetName.val)) { 
				if (_paramType.val =="NODE" && _atomType.val=="Person"){_targetName.val ="head";}
				else if (_paramType.val =="RB" && _atomType.val=="Person"){_targetName.val ="Any Node";}
				else {_targetName.val = _targetName.choices[0]; }
			}
            if (updateUI) { _parentVar.initVariableUI(); }
        }
        public void RegisterVarParam() {
			VUML parentMVR = _parentVar._parent;
			parentMVR.RegisterString(_paramType);parentMVR.RegisterStringChooser(_atomName);parentMVR.RegisterString(_atomType);parentMVR.RegisterStringChooser(_receiverGroupName);parentMVR.RegisterStringChooser(_receiverName);			parentMVR.RegisterStringChooser(_targetName);parentMVR.RegisterString(_staticStringValue);parentMVR.RegisterFloat(_staticFloatValue);parentMVR.RegisterBool(_staticBoolValue);
			if(_paramType.val=="BOOL"){parentMVR.RegisterBool(_invertBool);}
			else {parentMVR.DeregisterBool(_invertBool);}
		}
        public void DeregisterVarParam() { 
			VUML parentMVR = _parentVar._parent;
			parentMVR.DeregisterString(_paramType);parentMVR.DeregisterStringChooser(_atomName);parentMVR.DeregisterString(_atomType);parentMVR.DeregisterStringChooser(_receiverGroupName);parentMVR.DeregisterStringChooser(_receiverName);parentMVR.DeregisterStringChooser(_targetName);parentMVR.DeregisterBool(_invertBool);parentMVR.DeregisterString(_staticStringValue);parentMVR.DeregisterFloat(_staticFloatValue);parentMVR.DeregisterBool(_staticBoolValue);		
		}
        public void CopyParamFrom(VariableParam varParam) {
			_atomName.val = varParam._atomName.val;	_paramType.val = varParam._paramType.val;_atomType.val = varParam._atomType.val;_receiverGroupName.val = varParam._receiverGroupName.val;_receiverName.val = varParam._receiverName.val;_targetName.val = varParam._targetName.val;	_invertBool.val = varParam._invertBool.val;	_staticStringValue.val = varParam._staticStringValue.val;_staticFloatValue.val = varParam._staticFloatValue.val;_staticBoolValue.val = varParam._staticBoolValue.val;		
		}
        public void RestoreFromJSON(string varLabel, string AorB, JSONNode varSaveJSON) {
			if (varSaveJSON[varLabel+AorB+"TypeName"]!=null){_paramType.val =  varSaveJSON[varLabel+AorB+"TypeName"].Value;}
			if (varSaveJSON[varLabel+AorB+"AtomName"]!=null){_atomName.val = varSaveJSON[varLabel + AorB + "AtomName"].Value;}
			if (varSaveJSON[varLabel+AorB+"AtomType"]!=null){_atomType.val = varSaveJSON[varLabel + AorB + "AtomType"].Value;}
			if (varSaveJSON[varLabel+AorB+"ReceiverGroupName"]!=null){_receiverGroupName.val = varSaveJSON[varLabel + AorB + "ReceiverGroupName"].Value;}
			if (varSaveJSON[varLabel+AorB+"ReceiverName"]!=null){_receiverName.val = varSaveJSON[varLabel + AorB + "ReceiverName"].Value;}
			if (varSaveJSON[varLabel+AorB+"TargetName"]!=null){_targetName.val = varSaveJSON[varLabel + "" + AorB + "TargetName"].Value;}
			if (varSaveJSON[varLabel+AorB+"InvertBool"]!=null){_invertBool.val = varSaveJSON[varLabel + AorB + "InvertBool"].AsBool;}
			if (varSaveJSON[varLabel+AorB+"StaticBoolValue"]!=null){_staticBoolValue.val = varSaveJSON[varLabel + AorB + "StaticBoolValue"].AsBool;}
			if (varSaveJSON[varLabel+AorB+"StaticStringValue"]!=null){_staticStringValue.val = varSaveJSON[varLabel + AorB + "StaticStringValue"].Value;}
			if (varSaveJSON[varLabel+AorB+"StaticFloatValue"]!=null){_staticFloatValue.val = varSaveJSON[varLabel + AorB + "StaticFloatValue"].AsFloat;}
			if (_atomName.val == ""){_atomName.val = "LOCAL VUML";}
			if (_invertBool.val == null){_invertBool.val = false;}
			if (_staticBoolValue.val == null){_staticBoolValue.val = false;}
			if (_staticStringValue.val == null){_staticStringValue.val = "";}
			if (_staticFloatValue.val == null){_staticFloatValue.val = 0f;}
        }
        public void clearUI(){
            VUML parentMVR = _parentVar._parent;
			if (_displaySpacer !=null){parentMVR.RemoveSpacer(_displaySpacer);}
			if (_displayAtomPopup !=null){parentMVR.RemovePopup(_displayAtomPopup);}
            if (_displayReceiverGroupPopup != null) { parentMVR.RemovePopup(_displayReceiverGroupPopup); }					
            if (_displayReceiverPopup != null) { parentMVR.RemovePopup(_displayReceiverPopup); _displayReceiverPopup=null; }
            if (_displayTargetPopup != null) { parentMVR.RemovePopup(_displayTargetPopup); }
			if (_displayInvertBool != null) { parentMVR.RemoveToggle(_displayInvertBool); }
			if (_displayStaticBoolValue != null) { parentMVR.RemoveToggle(_displayStaticBoolValue); }
			if (_displayStaticStringValue != null) { parentMVR.RemoveTextField(_displayStaticStringValue); }
			if (_displayStaticFloatValue != null) { parentMVR.RemoveSlider(_displayStaticFloatValue); }
        }
        public void initVarParamUI(){
            VUML parentMVR = _parentVar._parent;
			string labelPostFix =""; string label ="Scope/ Atom\n";
            if (_isBParam) { labelPostFix = "(Param B)";  }
            else { labelPostFix = "(Param A)"; if(_paramType.val=="COLLIDER"){label = "Collider Atom\n";}}
			_displaySpacer = parentMVR.CreateSpacer(true); _displaySpacer.height = 40;
			_displayAtomPopup = parentMVR.CreateSetupScrollablePopup(_atomName,true,580f,this.SyncAtomChoices,label+labelPostFix);_displayAtomPopup.popup.onValueChangeHandlers +=SelectAtomName;
			if (_atomName.val !="Static"){initVarParamReceiverUI();}
			else if (_paramType.val =="FLOAT"){_displayStaticFloatValue=parentMVR.CreateSlider(_staticFloatValue,true);_displayStaticFloatValue.label="Float Value "+labelPostFix;}
			else if (_paramType.val =="BOOL"){_displayStaticBoolValue=parentMVR.CreateToggle(_staticBoolValue,true);_displayStaticBoolValue.label="Boolean Value "+labelPostFix;}
			else if (_paramType.val =="STRING"){_displayStaticStringValue=parentMVR.CreateTextInput(_staticStringValue,true);}
        }
        public void initVarParamReceiverUI(){
            VUML parentMVR = _parentVar._parent;
			string labelPostFix = "";
            if (_isBParam) { labelPostFix = "(Param B)"; }
            else { labelPostFix = "(Param A)"; }
			if (_atomName.val.Length >=4 && _atomName.val.Substring(_atomName.val.Length-4,4)!="VUML" && _paramType.val!="NODE" && _paramType.val!="COLLIDER"&& _paramType.val!="RB"){
				if (GetParamAtomCategory() == "People"){ _displayReceiverGroupPopup = parentMVR.CreateSetupScrollablePopup(_receiverGroupName, true, 570f, this.SyncReceiverGroupChoices, "Receiver Group\n" + labelPostFix);_displayReceiverGroupPopup.popup.onValueChangeHandlers += SelectReceiverGroup;}
				_displayReceiverPopup = parentMVR.CreateSetupScrollablePopup(_receiverName, true, 460f, this.SyncReceiverChoices, "Receiver\n" + labelPostFix);_displayReceiverPopup.popup.onValueChangeHandlers += SelectReceiver;
			}
			if ((_paramType.val!="COLLIDER" && _paramType.val!="NODE" && _paramType.val!="RB") || (_atomName.val!="NONE" && GetParamAtomType()=="Person")){initVarParamTargetUI();}
        }
        public void initVarParamTargetUI(){
            VUML parentMVR = _parentVar._parent;
			string labelPostFix = ""; string boolInvertLabelPostFix ="";
            if (_isBParam) { labelPostFix = _paramType.val +"\n(Param B)"; boolInvertLabelPostFix=" (Param B)";}
            else { labelPostFix = _paramType.val +"\n(Param A)"; boolInvertLabelPostFix=" (Param A)";}
            _displayTargetPopup = parentMVR.CreateSetupScrollablePopup(_targetName, true, 370f, this.SyncTargetChoices, "Target\n" + labelPostFix);_displayTargetPopup.popup.onValueChangeHandlers += SelectTarget;		
			if(_paramType.val=="BOOL"){
				_displayInvertBool = parentMVR.CreateToggle (_invertBool,true); _displayInvertBool.label="Invert Boolean" +boolInvertLabelPostFix;
				_displayInvertBool.toggle.onValueChanged.AddListener((bool val)=>{if (!_disableUIUpdates) { _parentVar._parent.SaveUIVariable(); }});
			}
        }
        public void SyncAtomChoices(){
            List<string> atomChoices = new List<string>();
			VUML.CloseAllPopup(_displayAtomPopup);
			if (_paramType.val =="RB"){atomChoices.Add("Any");atomChoices.Add("Either VR Hand");}
			if (_paramType.val =="RB" || (_paramType.val =="NODE" && _parentVar._operationType.val!="Look At")){atomChoices.Add("Left VR Hand");atomChoices.Add("Right VR Hand");}
			if(_paramType.val !="NODE" && _paramType.val !="COLLIDER"&& _paramType.val !="RB"){
				atomChoices.Add("LOCAL VUML");
				if (_paramType.val =="BOOL"||_paramType.val =="FLOAT"||_paramType.val =="STRING"){atomChoices.Add("Static");}
				foreach (Atom atom in SuperController.singleton.GetAtoms()) {
					foreach (string receiverName in atom.GetStorableIDs()){
						if (receiverName.Length>=4 && receiverName.Substring (receiverName.Length-4,4) =="VUML" && (atom.name!=_parentVar._parent.containingAtom.name || receiverName!=_parentVar._parent.storeId)) {atomChoices.Add(atom.name+">"+receiverName);}
					}				
				}
			}				
            foreach (Atom atom in SuperController.singleton.GetAtoms()) { if(atom.name!="[CameraRig]"&&(atom.name!="CoreControl"||_paramType.val!="NODE")&& (atom.type=="Person" || atom.type=="CollisionTrigger"||_paramType.val!="COLLIDER")){atomChoices.Add(atom.name+">");} }
			if (atomChoices.Count ==0){atomChoices.Add("NONE");}
			_atomName.choices = new List<string>();
            _atomName.choices = atomChoices;
        }
        public void SelectAtomName (string atomName){
            try {
				_parentVar.initVariableUI();Atom atom = GetParamAtom();
				if (atom!=null){_atomType.val = atom.type;}
				else{_atomType.val = "NONE";}
				ResetReceiverName(true);				
                if (!_disableUIUpdates) { _parentVar._parent.SaveUIVariable(); }  
            }catch (Exception e) { SuperController.LogError("Exception caught: " + e); }
        }
        public void SelectReceiverGroup(string groupName){ try{ResetReceiverName(true); if (!_disableUIUpdates) { _parentVar._parent.SaveUIVariable(); }  }catch (Exception e) { SuperController.LogError("Exception caught: " + e); } }
        public void SelectReceiver(string receiver){try{ResetTargetName(true);  if (!_disableUIUpdates) { _parentVar._parent.SaveUIVariable(); }  }catch (Exception e) { SuperController.LogError("Exception caught: " + e); }}
        public void SelectTarget(string target){try{if (!_disableUIUpdates) { _parentVar._parent.SaveUIVariable(); }}catch (Exception e) { SuperController.LogError("Exception caught: " + e); }}
        public void SelectInvertBool(bool invertBool){try{if (!_disableUIUpdates) { _parentVar._parent.SaveUIVariable(); }  }catch (Exception e) { SuperController.LogError("Exception caught: " + e); } }
		public void SyncReceiverGroupChoices(){
            List<string> receiverGroupChoices = new List<string>();
			VUML.CloseAllPopup(_displayReceiverGroupPopup);	receiverGroupChoices.Add("Node Controls"); receiverGroupChoices.Add("Node Animations"); receiverGroupChoices.Add("Collision Triggers"); receiverGroupChoices.Add("Hair"); receiverGroupChoices.Add("Clothing"); receiverGroupChoices.Add("Skin & Eyes");
            if (GetParamAtom() != null){
                List<string> receivers = GetParamAtom().GetStorableIDs();int countPlugins = 0;
                foreach (string receiver in receivers) { if (receiver.Contains("plugin#")) { countPlugins++; } }
                if (countPlugins > 0) { receiverGroupChoices.Add("Plugins"); }
            }
            receiverGroupChoices.Add("Physics"); receiverGroupChoices.Add("Presets"); receiverGroupChoices.Add("Speech"); receiverGroupChoices.Add("Morphs"); receiverGroupChoices.Add("Other"); _receiverGroupName.choices = new List<string>();_receiverGroupName.choices = receiverGroupChoices;
        }
		public void SyncReceiverChoices(){
            List<string> receiverChoices = new List<string>();VUML.CloseAllPopup(_displayReceiverPopup);
			if (_atomName.val == "LOCAL VUML"){receiverChoices.Add(_parentVar._parent.storeId);}
			else {			
				Atom atom = GetParamAtom();		
				if (atom != null){
					if ((_receiverGroupName.val == "Clothing" || _receiverGroupName.val == "Hair" || _receiverGroupName.val == "Physics" || _receiverGroupName.val == "Skin & Eyes" || _receiverGroupName.val == "Morphs") && atom.category == "People") { receiverChoices.Add("geometry"); }
					foreach (string receiverChoice in atom.GetStorableIDs()){
						JSONStorable receiver = GetParamAtom().GetStorableByID(receiverChoice);
						bool paramTypeInReceiver =false;
						if (_paramType.val=="BOOL"){if (receiver.GetBoolParamNames()!=null && receiver.GetBoolParamNames().Count>0){paramTypeInReceiver=true;}}
						else if (_paramType.val=="FLOAT"){if (receiver.GetFloatParamNames()!=null && receiver.GetFloatParamNames().Count>0){paramTypeInReceiver=true;}}
						else if (_paramType.val=="STRING"){if ((receiver.GetStringParamNames()!=null && receiver.GetStringParamNames().Count>0) || (receiver.GetStringChooserParamNames()!=null && receiver.GetStringChooserParamNames().Count>0) || (receiver.GetUrlParamNames()!=null && receiver.GetUrlParamNames().Count>0)){paramTypeInReceiver=true;}}
						if (paramTypeInReceiver){
							if (atom.category != "People") { receiverChoices.Add(receiverChoice); }
							else{
								bool foundReceiver = false;
								foreach (KeyValuePair<string, string> entry in VUML.MAPReceiversToGroups) {
									if (receiverChoice.Contains(entry.Key)){foundReceiver = true;if (_receiverGroupName.val == entry.Value) { receiverChoices.Add(receiverChoice); }break;}
								}
								if (!foundReceiver) { if (_receiverGroupName.val == "Other" && receiverChoice!="geometry") { receiverChoices.Add(receiverChoice); } }
							}
						}
					}
				}
			}
			if(receiverChoices.Count ==0){receiverChoices.Add("NONE");}		
			_receiverName.choices = new List<string>();_receiverName.choices = receiverChoices;
        }
		public void SyncTargetChoices(){
			try{
				List<string> choices = new List<string>(); VUML.CloseAllPopup(_displayTargetPopup);JSONStorable receiver = GetParamReceiver ();Atom atom = GetParamAtom();
				if (atom !=null &&(receiver!=null || _paramType.val == "NODE" || _paramType.val == "COLLIDER"|| _paramType.val == "RB")){
					List<string> targetParamNames = new List<string>();targetParamNames.Clear();
					if (_paramType.val == "BOOL") {targetParamNames = receiver.GetBoolParamNames();}
					if (_paramType.val == "STRING") {
						foreach (string paramName in receiver.GetStringParamNames()) {targetParamNames.Add(paramName);}
						foreach (string paramName in receiver.GetStringChooserParamNames()) {targetParamNames.Add(paramName);}
						foreach (string paramName in receiver.GetUrlParamNames()) {targetParamNames.Add(paramName);}}
					if (_paramType.val == "FLOAT"){targetParamNames = receiver.GetFloatParamNames();}
					if (_paramType.val == "NODE"){
						foreach (FreeControllerV3 fc in atom.freeControllers){
							if (GetParamAtomCategory() != "People"){targetParamNames.Add(fc.name);}
							else {
								if (fc.name == "control"){targetParamNames.Add(fc.name);}
								else if (fc.name.Substring(0,4)!="hair"&& fc.name!="eyeTargetControl") {targetParamNames.Add(fc.name.Substring(0,fc.name.Length-7));}
							}		
						}
						foreach (Rigidbody rb in atom.realRigidbodies){
							if (GetParamAtomCategory() == "People"  &&rb.name.Length>7 && rb.name.Substring(rb.name.Length-7,7) =="Trigger"){targetParamNames.Add(rb.name);}						
						}
					}
					if (_paramType.val == "RB"){
						if (_parentVar._operationType.val=="Collision" && GetParamAtomCategory() == "People"){targetParamNames.Add("Any Node");}
						foreach (string rbName in SuperController.singleton.GetRigidbodyNamesInAtom(atom.name)){
							if (GetParamAtomCategory() == "People" &&  (rbName.Length <7 || rbName.Substring(rbName.Length-7,7) !="Control") && (rbName.Length <4 ||rbName.Substring(0,4) !="hair")) {targetParamNames.Add(rbName); targetParamNames.Add(rbName); }						
						}
					}
					if (_paramType.val == "COLLIDER" && GetParamAtomCategory() == "People" ){
						
						foreach (Rigidbody rb in atom.rigidbodies){if (rb.name.Length>7 && rb.name.Substring(rb.name.Length-7,7) =="Trigger"){targetParamNames.Add(rb.name);}}
					}
					foreach (string paramName in targetParamNames){
						if(_atomName.val!="LOCAL VUML" && _atomName.val.Length >0 && _atomName.val.Substring(_atomName.val.Length-1,1)==">"){
							if (GetParamAtomCategory()=="People" && _receiverName.val =="geometry" ){
								bool isParamNameInOtherGroup = true;
								foreach (KeyValuePair<string, string> entry in VUML.MAPReceiverGeometryParamsToGroup){
									if (paramName.Contains(entry.Key)){isParamNameInOtherGroup = false;if (_receiverGroupName.val == entry.Value ){choices.Add(paramName);}}
								}
								if (isParamNameInOtherGroup && _receiverGroupName.val =="Morphs"){choices.Add(paramName);}
							}
							else{choices.Add(paramName);}
						}
						else {
							string paramNamePrefix = "v"+_paramType.val;
							if (paramName.StartsWith(paramNamePrefix) && paramName.EndsWith("Result") ){choices.Add(paramName);}
						}
					}
				}				
				if (choices.Count == 0) { choices.Add("NONE"); }
				_targetName.choices = new List<string>();_targetName.choices = choices;
			}catch (Exception e) { SuperController.LogError("Exception caught: " + e); }			
		}
		public Atom GetParamAtom(){
			if (_atomName.val=="LOCAL VUML"){return(_parentVar._parent.containingAtom);}
			else if (_atomName.val.Substring(_atomName.val.Length-1,1)==">"){return (SuperController.singleton.GetAtomByUid(_atomName.val.Substring(0,_atomName.val.Length-1)));}
			else{String[] strlist = _atomName.val.Split('>');return (SuperController.singleton.GetAtomByUid(strlist[0]));}
		}
        public string GetParamAtomCategory(){Atom atom = GetParamAtom();string atomCategory = "";if (atom!=null){atomCategory = atom.category;}return (atomCategory);}
		public string GetParamAtomType(){Atom atom = GetParamAtom();string atomType = "";if (atom!=null){atomType = atom.type;}return (atomType);}
		public JSONStorable GetParamReceiver (){
			Atom atom = GetParamAtom();
			if (atom !=null) {
				if (_atomName.val=="LOCAL VUML"){return(atom.GetStorableByID(_parentVar._parent.storeId));}
				else if (_atomName.val.Substring(_atomName.val.Length-1,1)!=">") {String[] strlist = _atomName.val.Split('>');return(atom.GetStorableByID(strlist.Last()));}
				else {return (atom.GetStorableByID(_receiverName.val));}				
			}
			return (null);
		}
        public void CloseAllPopup(UIDynamicPopup exception){
            if (_displayAtomPopup!=null && _displayAtomPopup != exception) { _displayAtomPopup.popup.visible = false; }
            if (_displayReceiverGroupPopup != null && _displayReceiverGroupPopup != exception) { _displayReceiverGroupPopup.popup.visible = false; }
            if (_displayReceiverPopup != null && _displayReceiverPopup != exception) { _displayReceiverPopup.popup.visible = false; }
            if (_displayTargetPopup != null && _displayTargetPopup != exception) { _displayTargetPopup.popup.visible = false; }
        }
		public bool IsValidBoolParam(){if (_atomName.val =="Static"){return(true);}JSONStorable receiver = GetParamReceiver ();if (receiver !=null){return (receiver.IsBoolJSONParam(_targetName.val));} return(false);}
		public bool GetBoolResult(){if (_atomName.val =="Static"){return(_staticBoolValue.val);}if (IsValidBoolParam()){if (!_invertBool.val){return(GetParamReceiver().GetBoolJSONParam(_targetName.val).val);}else {return(!GetParamReceiver().GetBoolJSONParam(_targetName.val).val);}}return(false);}
		public bool IsValidFloatParam(){if (_atomName.val =="Static"){return(true);}JSONStorable receiver = GetParamReceiver ();if (receiver !=null){return (receiver.IsFloatJSONParam(_targetName.val));} return(false);}
		public float GetFloatResult(){if (_atomName.val =="Static"){return(_staticFloatValue.val);}if (IsValidFloatParam()&&_targetName.val!="NONE"){return(GetParamReceiver().GetFloatJSONParam(_targetName.val).val);}return(0f);}
		public bool IsValidStringParam(){if (_atomName.val =="Static"){return(true);}JSONStorable receiver = GetParamReceiver ();if (receiver !=null){return (receiver.IsStringJSONParam(_targetName.val)||receiver.IsStringChooserJSONParam(_targetName.val)||receiver.IsUrlJSONParam(_targetName.val));} return(false);}
		
		public string GetStringResult(){
			if (_atomName.val =="Static"){
				string staticStringValue = _staticStringValue.val;
				while (staticStringValue.Contains("<vSTRING") || staticStringValue.Contains("<vFLOAT") || staticStringValue.Contains("<vBOOL")){
					if (staticStringValue.Contains("<vSTRING")){
						int startIndex = staticStringValue.IndexOf("<vSTRING");
						int endIndex = staticStringValue.Substring(startIndex+1).IndexOf(">");
						if (endIndex ==-1){break;}
						string variableName = staticStringValue.Substring(startIndex+1,endIndex);
			
						if (_parentVar._varLabel=="vBOOL0" || variableName==_parentVar._varLabel){break;}
						if (!_parentVar._parent._vumlVariableDict.ContainsKey(variableName)){break;}
						string variableValue = _parentVar._parent._vumlVariableDict[variableName]._variableStringResult.val;
						staticStringValue= staticStringValue.Substring(0,startIndex)+variableValue+staticStringValue.Substring(startIndex+variableName.Length+2);
					}
					if (staticStringValue.Contains("<vFLOAT")){
						int startIndex = staticStringValue.IndexOf("<vFLOAT");
						int endIndex = staticStringValue.Substring(startIndex+1).IndexOf(">");
						if (endIndex ==-1){break;}
						string variableName = staticStringValue.Substring(startIndex+1,endIndex);
						if (_parentVar._varLabel=="vBOOL0" || variableName==_parentVar._varLabel){break;}
						if (!_parentVar._parent._vumlVariableDict.ContainsKey(variableName)){break;}
						string variableValue = _parentVar._parent._vumlVariableDict[variableName]._variableFloatResult.val.ToString();
						staticStringValue= staticStringValue.Substring(0,startIndex)+variableValue+staticStringValue.Substring(startIndex+variableName.Length+2);
					}
					if (staticStringValue.Contains("<vBOOL") && !staticStringValue.Contains("<vBOOL0") ){
						int startIndex = staticStringValue.IndexOf("<vBOOL");
						int endIndex = staticStringValue.Substring(startIndex+1).IndexOf(">");
						if (endIndex ==-1){break;}
						string variableName = staticStringValue.Substring(startIndex+1,endIndex);
						if (_parentVar._varLabel=="vBOOL0" || variableName==_parentVar._varLabel){break;}
						if (!_parentVar._parent._vumlVariableDict.ContainsKey(variableName)){break;}
						string variableValue = _parentVar._parent._vumlVariableDict[variableName]._variableBoolResult.val.ToString();
						staticStringValue= staticStringValue.Substring(0,startIndex)+variableValue+staticStringValue.Substring(startIndex+variableName.Length+2);
					}					
				}
				return(staticStringValue);
			}
			JSONStorable receiver = GetParamReceiver ();
			if (IsValidStringParam()){
				if (receiver.IsStringJSONParam(_targetName.val)){return(receiver.GetStringJSONParam(_targetName.val).val);}
				if (receiver.IsStringChooserJSONParam(_targetName.val)){return(receiver.GetStringChooserJSONParam(_targetName.val).val);}
				if (receiver.IsUrlJSONParam(_targetName.val)){return(receiver.GetUrlJSONParam(_targetName.val).val);}
			}
			return("");
		}
		public bool IsValidNodeParam(){
			if (_atomName.val == "Left VR Hand" || _atomName.val == "Right VR Hand" || _atomName.val == "Either VR Hand" || _atomName.val == "Any" || _atomName.val == "None"){return(true);}
			Atom atom = GetParamAtom ();
			if (atom!=null){
				if (_targetName.val=="Any Node" || atom.type!="Person") return(true);
				foreach (FreeControllerV3 fc in atom.freeControllers){
					if (fc.name=="control" && _targetName.val=="control"){return(true);}
					else if (atom.type == "Person" && fc.name==_targetName.val+"Control"){return(true);}
					else if (fc.name==_targetName.val){return(true);}
				}
				foreach (Rigidbody rb in atom.rigidbodies){
					if (rb.name==_targetName.val){return(true);}
				}
			}
			return(false);
		}
		public Vector3 GetNodePosition(){
			Vector3 nodePosition = new Vector3();
			if (_atomName.val == "Left VR Hand"){return(SuperController.singleton.leftHand.position);}
			else if (_atomName.val == "Right VR Hand"){return(SuperController.singleton.rightHand.position);}
			else if (IsValidNodeParam()){
				Atom atom = GetParamAtom ();
				foreach (FreeControllerV3 fc in atom.freeControllers){ 
					if (fc.name=="control" && _targetName.val=="control"){return(fc.transform.position);}
					else if (atom.type=="Person" && fc.name==_targetName.val+"Control"){return(fc.followWhenOff.position);}
					else if (fc.name==_targetName.val){return(fc.transform.position);}
				}
				foreach (Rigidbody rb in atom.realRigidbodies){if (rb.name==_targetName.val){return(rb.transform.position);}}
			}
			return (nodePosition);
		}
		public bool IsValidParam(){
			if (_paramType.val=="FLOAT"){return (IsValidFloatParam());}
			if (_paramType.val=="BOOL"){return (IsValidBoolParam());}
			if (_paramType.val=="STRING"){return (IsValidStringParam());}
			if (_paramType.val=="NODE"||_paramType.val=="RB"||_paramType.val=="COLLIDER"){return (IsValidNodeParam());}
			return(false);		
		}
		public JSONStorableString _paramType; public JSONStorableStringChooser _atomName ; 	public JSONStorableString _atomType; public JSONStorableStringChooser _receiverGroupName ;public JSONStorableStringChooser _receiverName ;public JSONStorableStringChooser _targetName ;public JSONStorableBool _invertBool;public JSONStorableBool _staticBoolValue;public JSONStorableString _staticStringValue;public JSONStorableFloat _staticFloatValue;public UIDynamicPopup _displayAtomPopup ; public UIDynamicPopup _displayReceiverGroupPopup ; public UIDynamicPopup _displayReceiverPopup ;  public UIDynamicPopup _displayTargetPopup ;	public UIDynamicToggle _displayInvertBool;UIDynamicTextField _displayStaticStringValue;public UIDynamicToggle _displayStaticBoolValue;public UIDynamicSlider _displayStaticFloatValue;public UIDynamic _displaySpacer;public VUMLVariable _parentVar;public bool _disableUIUpdates = false;public bool _isBParam;
	}
	public class TriggerEventArgs:EventArgs { public Collider collider { get; set; }public string evtType { get; set; }}
    public class TriggerCollide :MonoBehaviour{
        TriggerEventArgs lastEvent;
        public event EventHandler<TriggerEventArgs> OnCollide;
        void Awake(){lastEvent = new TriggerEventArgs{evtType = "none", collider = null};}
        private void OnTriggerEnter(Collider other){DoCollideEvent("Enter", other);}
        private void OnTriggerExit(Collider other){DoCollideEvent("Exit", other);}
        private void OnTriggerStay(Collider other){DoCollideEvent("Enter", other);}
        private void DoCollideEvent(string evtType,Collider col){
            if (string.Equals(evtType, lastEvent.evtType) && col.gameObject == lastEvent.collider.gameObject){return;}
            else {TriggerEventArgs tempEvent = new TriggerEventArgs{collider = col,evtType = evtType};OnCollideEvent(tempEvent);lastEvent = tempEvent;}
        }
        protected virtual void OnCollideEvent(TriggerEventArgs e) {EventHandler<TriggerEventArgs> handler = OnCollide;handler?.Invoke(this, e); }
	}
}
